<?xml version="1.0"?>

<queryset>
   <rdbms><type>oracle</type><version>8.1.6</version></rdbms>

<fullquery name="mail_job::sweeper.get_queued_mail_jobs">
      <querytext>
      
		select mail_job_id
		from ml_mail_jobs
		where state = 'active'
		and scheduled_date <= sysdate
	    
      </querytext>
</fullquery>

 
<fullquery name="mail_job::send.start_mail_job">
      <querytext>
      
	    update ml_mail_jobs
	    set state = 'started',
	        execution_date = sysdate
	    where mail_job_id = :mail_job_id
	
      </querytext>
</fullquery>

 
<fullquery name="mail_job::send.get_attachments">
      <querytext>
      
	    select r.mime_type, r.title, r.filename
	    from cr_revisions r
	    where r.revision_id = :css_revision_id
	    union
	    select r.mime_type, r.title, r.filename
	    from cr_items i, cr_revisions r
	    where r.item_id = i.item_id
	    and i.parent_id = :mail_job_id
	
      </querytext>
</fullquery>

 
<fullquery name="mail_job::send.log_users_latest_mail">
      <querytext>
      
		update ml_user_email_log
		set last_mail_date = sysdate
		where user_id = :user_id
	    
      </querytext>
</fullquery>

 
<fullquery name="mail_job::send.finish_mail_job">
      <querytext>
      
		update ml_mail_jobs
		set state = 'finished',
	            mails_sent = :mail_count,
	            track_links_p = (select case when count(*) = 0 then 'f' else 't' end
				     from mail_link_mail_map m
				     where mail_id = :mail_job_id)
		where mail_job_id = :mail_job_id
	    
      </querytext>
</fullquery>


<fullquery name="mail_job::mail_bounced.record_bounce_in_log">
      <querytext>
      
			insert into ml_bounce_log (mail_job_id, user_id, sending_time,
						   bouncing_time)
			(select mail_job_id, user_id, send_date as sending_time,
			 sysdate as bouncing_time
			 from ml_email_log
			 where mail_job_id = :job_id
			 and user_id = :user_id)
		    
      </querytext>
</fullquery>

 
</queryset>
