<?xml version="1.0"?>

<queryset>
   <rdbms><type>oracle</type><version>8.1.6</version></rdbms>

<fullquery name="mailing_list::add.insert_mailing_list">
      <querytext>
		begin
		:1 := ml_mailing_list.new (
					   list_id => :list_id,
					   package_id => :package_id,
					   name => :name,
					   locale => :locale,
					   sender_email => :sender_email,
					   confirm_subject => :confirm_subject,
					   confirm_mime_type => :confirm_mime_type,
					   welcome_subject => :welcome_subject,
					   welcome_mime_type => :welcome_mime_type,
					   remind_subject => :remind_subject,
					   remind_mime_type => :remind_mime_type,
					   expiration_date => $expiration_date,
					   first_reminder => :first_reminder,
					   second_reminder => :second_reminder,
					   context_id => :package_id,
					   creation_user => :user_id,
					   creation_ip => :creation_ip);
		end;
      </querytext>
</fullquery>

 
<fullquery name="mailing_list::edit.update_mailing_list">
      <querytext>
		begin
		ml_mailing_list.edit (
				      list_id => :list_id,
				      name => :name,
				      locale => :locale,
				      sender_email => :sender_email,
				      confirm_subject => :confirm_subject,
				      confirm_mime_type => :confirm_mime_type,
				      welcome_subject => :welcome_subject,
				      welcome_mime_type => :welcome_mime_type,
				      remind_subject => :remind_subject,
				      remind_mime_type => :remind_mime_type,
				      expiration_date => $expiration_date,
				      first_reminder => :first_reminder,
				      second_reminder => :second_reminder,
				      modifying_user => :user_id,
				      modifying_ip => :modifying_ip);
		end;
      </querytext>
</fullquery>

 
<fullquery name="mailing_list::add_user.add_user_entry">
      <querytext>
      
		insert into ml_mailing_list_user_map
		(list_id, user_id, confirmed_p, subscribed_p, subscription_date)
		values (:list_id, :user_id, :confirmed_p, :confirmed_p, sysdate)
	    
      </querytext>
</fullquery>

 
<fullquery name="mailing_list::send_reminder.get_unconfirmed_subscriptions">
      <querytext>
      
	    select m.user_id, ml.sender_email, ml.remind_subject,
		   ml.remind_body, ml.remind_mime_type, l.mime_charset,
		   ml.list_id, n.node_id, ml.package_id
	    from ml_mailing_lists ml, ml_mailing_list_user_map m,
		 ad_locales l, site_nodes n
	    where m.list_id = ml.list_id
	    and ml.locale = l.locale
	    and m.confirmed_p = 'f'
	    and n.object_id = ml.package_id
	    and ml.remind_body is not null
	    and ((m.reminder_count = 0
		  and ml.first_reminder > 0
		  and m.subscription_date < sysdate - ml.first_reminder)
		 or (m.reminder_count = 1
		     and ml.second_reminder > 0
		     and m.subscription_date < sysdate - ml.second_reminder))
	
      </querytext>
</fullquery>

 
<fullquery name="mail_class::add.insert_mail_class">
      <querytext>
      
		begin
		:1 := ml_mail_class.new (
					 mail_class_id => :mail_class_id,
					 package_id => :package_id,
					 name => :name,
					 locale => :locale,
					 sender_email => :sender_email,
					 subject => :subject,
					 subject_change_p => :subject_change_p,
					 text_header_change_p => :text_header_change_p,
					 text_body_change_p => :text_body_change_p,
					 text_footer_change_p => :text_footer_change_p,
					 html_header_change_p => :html_header_change_p,
					 html_body_change_p => :html_body_change_p,
					 html_footer_change_p => :html_footer_change_p,
					 mime_type => :mime_type,
					 context_id => :package_id,
					 creation_user => :user_id,
					 creation_ip => :creation_ip);
		end;
	    
      </querytext>
</fullquery>

 
<fullquery name="mail_class::edit.update_mail_class">
      <querytext>
      
		begin
		ml_mail_class.edit (
				    mail_class_id => :mail_class_id,
				    name => :name,
				    locale => :locale,
				    sender_email => :sender_email,
				    subject => :subject,
				    subject_change_p => :subject_change_p,
				    text_header_change_p => :text_header_change_p,
				    text_body_change_p => :text_body_change_p,
				    text_footer_change_p => :text_footer_change_p,
				    html_header_change_p => :html_header_change_p,
				    html_body_change_p => :html_body_change_p,
				    html_footer_change_p => :html_footer_change_p,
				    mime_type => :mime_type,
				    modifying_user => :user_id,
				    modifying_ip => :modifying_ip);
		end;
	    
      </querytext>
</fullquery>

 
<fullquery name="mail_job::add.insert_mail_job">
      <querytext>
		begin
		:1 := ml_mail_job.new (
				       mail_class_id => :class_id,
				       list_id => :list_id,
				       selection_id => :selection_id,
				       package_id => :package_id,
				       locale => :locale,
				       sender_email => :sender_email,
				       track_links_p => :track_links_p,
				       subject => :subject,
				       template_p => :template_p,
				       mime_type => :mime_type,
				       state => :state,
				       scheduled_date => $scheduled_date,
				       bind_vars => :bind_vars,
				       context_id => :class_id,
				       creation_user => :user_id,
				       creation_ip => :creation_ip);
		end;
      </querytext>
</fullquery>

 
<fullquery name="mail_job::edit.update_mail_job">
      <querytext>
		begin
		ml_mail_job.edit (
				  mail_job_id => :mail_job_id,
				  locale => :locale,
				  sender_email => :sender_email,
				  track_links_p => :track_links_p,
				  subject => :subject,
				  template_p => :template_p,
				  mime_type => :mime_type,
				  state => :state,
				  scheduled_date => $scheduled_date,
				  bind_vars => :bind_vars,
				  modifying_user => :user_id,
				  modifying_ip => :modifying_ip);
		end;
      </querytext>
</fullquery>

 
</queryset>
