ad_page_contract {
} {
    locale:optional
    user_id:optional
    x:optional
} -properties {
    lists:multirow
    jobs:multirow
}

if {[exists_and_not_null user_id] && [exists_and_not_null x]} {
    # user most likely clicked a link in an email
    # verify the secret key and try to login the user
    if {[mailing_list::util::valid_x_field_p -user_id $user_id -x_field $x]} {
	# secret key ok, login user
	ad_user_login -forever=0 $user_id
    } else {
	# could not verify the secret key for that user
	ad_return_complaint 1 "Invalid secret key"
	return
    }
} else {
    set user_id [auth::require_login]
}

set package_id [ad_conn package_id]
set admin_p [permission::permission_p -object_id $package_id -privilege mailing_list_admin]

set context_bar ""

db_1row check_email_verified_p {}

if {$email_verified_p == "t"} {
    if {![info exists locale]} {
	set locale [ad_conn locale]
    }

    db_multirow subscribed_lists get_lists_user_is_subscribed {}

#    template::multirow create lists list_id name teaser tree_id tree_name category_id category_name
    template::multirow create lists list_id name teaser

    db_foreach get_lists_by_language_new {} {
	if {$subscribed_p == "f"} {
#	    set category_name [category::get_name $category_id]
#	    set tree_name [category_tree::get_name $tree_id]
#	    template::multirow append lists $list_id $name $teaser $tree_id $tree_name $category_id $category_name
	    template::multirow append lists $list_id $name $teaser
	}
    }

    db_multirow languages get_languages {}
}

set return_url [ad_return_url]
ad_return_template
