ad_page_contract {

    Displays the country category tree and lets user map country codes
    (to be used in mass subscribtion)

    @author Timo Hentschel (thentschel@sussdorff-roy.com)
    @cvs-id $Id:
} {
} -properties {
    context_bar:onevalue
    one_tree:multirow
}

set user_id [auth::require_login]
set package_id [ad_conn package_id]
permission::require_permission -object_id $package_id -privilege mailing_list_admin

set context_bar [list [list "." Administration] "Country Codes"]

if {![db_0or1row get_current_country_category_tree {}]} {
    # no country tree mapped, so return to index page immediately
    ad_returnredirect "."
    return
}

db_foreach get_country_codes {} {
    set country_codes($category_id) $country_code
}

template::multirow create one_tree category_name country_code category_id deprecated_p level left_indent

foreach category [category_tree::get_tree -all $tree_id] {
    util_unlist $category category_id category_name deprecated_p level
    if {[catch {set country_code $country_codes($category_id)}]} {
	set country_code ""
    }

    template::multirow append one_tree $category_name $country_code $category_id $deprecated_p $level [category::repeat_string "&nbsp;" [expr ($level-1)*5]]
}

ad_return_template
