ad_page_contract {
} {
    from_date:array,optional
    to_date:array,optional
    {view day}
    {date ""}
} -properties {
    jobs:multirow
    date_widget:onerow
    start_date:onerow
    end_date:onerow
}

set user_id [auth::require_login]
set package_id [ad_conn package_id]
permission::require_permission -object_id $package_id -privilege mailing_list_admin

if {[empty_string_p $date]} {
    set date [join [util::date::get_property linear_date_no_time [util::date::now]] -]
    if {[info exists from_date]} {
	set start_date "$from_date(year)-$from_date(month)-$from_date(day)"
    }
    if {[info exists to_date]} {
	set end_date "$to_date(year)-$to_date(month)-$to_date(day)"
    }
} else {
    switch $view {
	day - list {
	    set start_date $date
	    set end_date $date
	}
	week {
	    set start_date $date
	    db_1row get_week_dates {}
	}
	month {
	    set year [lindex [split $date -] 0]
	    set month [lindex [split $date -] 1]
	    set start_date "$year-$month-01"
	    db_1row get_end_of_month {}
	}
    }
}

db_multirow -extend {user_name} jobs ml_mail_job_history {} {
    if {[string equal $user_first_names "first_names"]} {
	set user_first_names ""
    }
    if {[string equal $user_last_name "last_name"]} {
	set user_last_name ""
	set user_name $user_first_names
    } else {
	set user_name "$user_first_names $user_last_name"
    }
}

set context_bar [list [list "." Administration] [list job-history "Mail Job History"] "Show"]

set date_widget [dt_widget_calendar_navigation job-history-2 $view $date]

ad_return_template
