<?xml version="1.0"?>
<queryset>

<fullquery name="get_default_data">
      <querytext>
      
    select subject_change_p, text_header_change_p, text_body_change_p,
           text_footer_change_p, html_header_change_p, html_body_change_p,
           html_footer_change_p, subject as default_subject,
           text_header as default_text_header, text_body as default_text_body,
           text_footer as default_text_footer, html_header as default_html_header,
           html_body as default_html_body, html_footer as default_html_footer
    from ml_mail_classes
    where mail_class_id = :class_id

      </querytext>
</fullquery>

<fullquery name="get_selection_title">
 <querytext>
   select title as selection_name
   from us_selections
   where selection_id = :selection_id
</querytext>
</fullquery>
 
<fullquery name="get_list_name">
 <querytext>
   select name as list_name
   from ml_mailing_lists
   where list_id = :list_id
</querytext>
</fullquery>

 
<fullquery name="get_old_css_file">
      <querytext>
      
	select r.title || ' (' || r.content_length || ' bytes)' as css_file
	from cr_revisions r, ml_mail_jobs j
	where r.revision_id = j.css_revision_id
	and j.mail_job_id = :mail_job_id

      </querytext>
</fullquery>

 
<fullquery name="get_current_css_file">
      <querytext>
      
	select r.title || ' (' || r.content_length || ' bytes)' as css_file
	from cr_revisions r, cr_items i
	where r.revision_id = i.live_revision
	and i.parent_id = :class_id
    
      </querytext>
</fullquery>

 
<fullquery name="get_attachments">
      <querytext>
      
    select r.title || ' (' || r.content_length || ' bytes)' as file_name
    from cr_items i, cr_revisions r
    where i.parent_id = :mail_job_id
    and r.revision_id = i.latest_revision

      </querytext>
</fullquery>

 
<fullquery name="get_mail_job_sql_query">
      <querytext>
      
	    select sql_query
	    from ml_mail_jobs
	    where mail_job_id = :mail_job_id
	
      </querytext>
</fullquery>

 
<fullquery name="get_users_selection_query">
      <querytext>
      
		select full_sql as sql_query
		from us_selections
		where selection_id = :selection_id
	    
      </querytext>
</fullquery>

 
</queryset>
