<?xml version="1.0"?>

<queryset>
   <rdbms><type>oracle</type><version>8.1.6</version></rdbms>

<fullquery name="grant_user_list_read_privilege">
      <querytext>
      
		begin
		  acs_permission.grant_permission (
						   object_id => :list_id,
						   grantee_id => :the_public_id,
						   privilege => 'read'
						   );
		end;
	    
      </querytext>
</fullquery>

 
<fullquery name="revoke_user_list_read_privilege">
      <querytext>
      
		begin
		  acs_permission.revoke_permission (
						    object_id => :list_id,
						    grantee_id => :the_public_id,
						    privilege => 'read'
						    );
		end;
	    
      </querytext>
</fullquery>

 
<fullquery name="get_all_mailing_list_admins">
      <querytext>
      
	select acs_permission.permission_p(:list_id, oppm.party_id, :privilege) as permission_p,
	       oppm.party_id
	from acs_object_party_privilege_map oppm
	where oppm.object_id = :package_id
	and oppm.privilege = 'mailing_list_admin'
	and oppm.party_id <> :user_id
	and acs_permission.permission_p(:package_id, oppm.party_id, 'admin') = 'f'
    
      </querytext>
</fullquery>

 
<fullquery name="grant_user_list_privilege">
      <querytext>
      
		begin
		  acs_permission.grant_permission (
						   object_id => :list_id,
						   grantee_id => :users_id,
						   privilege => :privilege
						   );
		end;
	    
      </querytext>
</fullquery>

 
<fullquery name="revoke_user_list_privilege">
      <querytext>
      
		begin
		  acs_permission.revoke_permission (
						    object_id => :list_id,
						    grantee_id => :users_id,
						    privilege => :privilege
						    );
		end;
	    
      </querytext>
</fullquery>

 
</queryset>
