ad_page_contract {
    Show weekly cliks on a link from a given mail job  , brocken down by hour.

    @cvs-id $Id: stats-weekly.tcl,v 1.2 2004/01/21 19:22:15 maltes Exp $
} {
    date:optional
    {adp_list_name "GENERAL"}
    sel_month:optional
    sel_year:optional
    link_id:notnull
    mail_job_id:notnull
    {type "list"}

} -properties {
    context_bar:onevalue
    subscriptions:multirow
    dates_available:onevalue
    next_week_available:onevalue
    last_week_available:onevalue
    next_week:onevalue
    last_week:onevalue
    pretty_week_date:onevalue
}

### some preparation
set julian_linux_diff 2440588
set dates_available true
set date_first 0
set date_last 0

set package_id [ad_conn package_id]
set context_bar [list [list "." Administration] [list job-history "Mail Job History"] [list link-track?mail_job_id=$mail_job_id "Link Tracking"] [list stats-all-region?link_id=$link_id&mail_job_id=$mail_job_id "Alphanumeric Statistics"] "Chart Statistics"]
set mailing_list_package_id [user_register::util::get_sw_package_id -package_key mailing-lists]

if {![db_0or1row get_current_country_category_tree {}]} {
    # no country tree mapped, so return to index page immediately
    ad_returnredirect "."
    return
}

# set the date var if it wasn't supplied (directly) in the querry
if {![info exists date]} {
 
   if {[info exists sel_year] && [info exists sel_month]} {
	set date [expr $sel_year + [expr [expr $sel_month - 1] * 31]]
    } else {
	# set date to current date
	set count 0

	db_foreach get_first_date {} {
	    if {$count == 0} {
		set date $cur_date
		set date_first $cur_date    
		incr count
	    }
	} if_no_rows {set dates_available "false"}
	
	if {$dates_available == "true"} {
	    set date_last $cur_date
	} else {
	    # If no one has clicked the link(_id) in this  mail(_job_id) we dont need a Chart.
	    ad_return_template
	    ad_script_abort
	}
    }
}

set count 0

#multirow create image_names image_name region_id list_id region

set region_value_lists [list ]
set region_day_lists [list ]
set count 0

db_foreach get_category_ids_for_region {} {
 
    set regions_array($cur_category_id) [category::get_name $cur_category_id]
    lappend region_ids_list $cur_category_id 
    set region_values($cur_category_id) [list]
    set region_days($cur_category_id) [list]
    set region_lists_index($cur_category_id) $count
   
    lappend region_value_lists [list 0 0]
    lappend region_day_lists [list start point]
    set count [expr $count + 1]
    set bar_chart_array($cur_category_id) 0
}


### some preparation end 


### we have to display weekly stats split in all 168 hours 
set this_week_start [expr $date - [ns_fmttime  [expr [expr $date - $julian_linux_diff] * 86400] "%w"]]
set this_week_end [expr $this_week_start + 6]
set number_of_intervals 168
set pretty_week_date [ns_fmttime  [expr [expr $this_week_start - $julian_linux_diff] * 86400] "The Week from %A the %d of %B %Y"]
append pretty_week_date [ns_fmttime  [expr [expr $this_week_end - $julian_linux_diff] * 86400] " -- to %A the %d of %B %Y"]

# we proberbly won't need a multirow here ()
template::multirow create pretty_regions region_name
set bar_chart_legende [list]

foreach bar_region [array names bar_chart_array] {

    lappend bar_chart_legende [category::get_name $bar_region]
    # Create a mult. with region lables
    template::multirow append pretty_regions [category::get_name $bar_region]

    # Create a ns_set for each region
    set temp_set [ns_set create]

    # Loop through all 168 hours of this week
    # I split the Loop into two Loops one counts the days (7) one the hours of a day (24)
    # This makes it easyer to create a datetime value.
 
    for {set this_week_day 0} {$this_week_day < 7} {incr this_week_day} {
    
	for {set cur_hours 0} {$cur_hours < 24} {incr cur_hours} {

	    set cur_day_date [expr $this_week_day + $this_week_start]
	    # set format like "24 12 2000"
	    set time_stamp [ns_fmttime [expr [expr $cur_day_date - $julian_linux_diff] * 86400] "%d %m %Y" ]
	    append time_stamp " "
	    if {[string len $cur_hours] == 1} {
		append time_stamp "0"
	    }
	    
	    append time_stamp $cur_hours

	    ns_set cput $temp_set  $time_stamp  0

	    ### set all possible hours of this week to 0 values
	}
    }

    # Put all set id's into a array the keys are the region id's
    set bar_chart_array($bar_region) $temp_set
}


for {set i 1} {$i <= 168} {incr i} {
    switch $i {
	1 {lappend bar_chart_lables "Sunday"}
	25 {lappend bar_chart_lables "Monday"}
	49 {lappend bar_chart_lables "Tuesday"}
	73 {lappend bar_chart_lables "Wednesday"}
	97 {lappend bar_chart_lables "Thursday"}
	121 {lappend bar_chart_lables "Friday"}
	145 {lappend bar_chart_lables "Saturday"}
	
	default {lappend bar_chart_lables ""}
    }
}

# Now query the db for all clicks of this week. I formate the click_time to a
# datetime value, wich is precise to one hour and equaly formated as the keys
# of the above createt sets.  

set time_stamp_start [ns_fmttime [expr [expr $this_week_start - $julian_linux_diff] * 86400] "%d %m %Y" ]
set time_stamp_end [ns_fmttime [expr [expr [expr $this_week_end - $julian_linux_diff] * 86400] + 86401] "%d %m %Y" ]
append time_stamp_start " 00"
append time_stamp_end " 00"

db_foreach get_link_clicks_dev {} {
    ns_set update $bar_chart_array($category_id) $cur_ns_set_key $number_clicks 
} 


# Get out the values from the ns_set and stuff then into lists,
# Which the Chart drawing functions expect.

set bar_chart_values [list]
lappend bar_chart_values $bar_chart_lables
 
foreach bar_region [array names bar_chart_array] {

    set temp_list [list]
    set temp_set $bar_chart_array($bar_region)

   for {set this_week_day 0} {$this_week_day < 7} {incr this_week_day} {
    
	for {set cur_hours 0} {$cur_hours < 24} {incr cur_hours} {

	    set cur_day_date [expr $this_week_day + $this_week_start]
	    # set format like "24 12 2000"
	    set time_stamp [ns_fmttime [expr [expr $cur_day_date - $julian_linux_diff] * 86400] "%d %m %Y" ]
	    append time_stamp " "
	    if {[string len $cur_hours] == 1} {
		append time_stamp "0"
	    }
	    
	    append time_stamp $cur_hours
	    lappend temp_list [ns_set value $temp_set [ns_set find $temp_set $time_stamp]] 
	}
    }

    lappend bar_chart_values $temp_list
}


set file_name "link-detail-$link_id-$mail_job_id-$this_week_start"

set ret_val [tgdchart::smallstackbar -file $file_name -title "Link Clicks for one Week"   -ytitle "Clicks"   -xtitle "Hours"      -values "$bar_chart_values"  -legende $bar_chart_legende]


set file_name [lindex $ret_val 0]
set image_map  [lindex $ret_val 1]
regsub -all {index[0-9]+} $image_map "" image_map
regsub -all {href=\"test\?stats-lists-nopage\"} $image_map  "" image_map

# The Chart Image is created , now create the back and forth links
# Get the first and last day, someone clicked the link (if we haven't gotten it yet)

if {$date_last == 0 && $date_first == 0} {

    set count 0
    db_foreach get_first_date {}  {
		
	if {$count == 0} {
	    set date_first $cur_date    
	    incr count
	}
    } if_no_rows {set dates_available "false"}
}	
	

if {$dates_available == "true"} {
 
    set date_last $cur_date
    set first_week_start [expr $date_first - [ns_fmttime  [expr [expr $date_first - $julian_linux_diff] * 86400] "%w"]]

    if {$first_week_start < $this_week_start} {
	set last_week_available true
	set last_week [expr $this_week_start - 6]
    } else {
	set last_week_available false
    }

    set last_week_start [expr $date_last - [ns_fmttime  [expr [expr $date_last - $julian_linux_diff] * 86400] "%w"]]

    if {$last_week_start > $this_week_start} {
	set next_week_available true
	set next_week [expr $this_week_start + 7]
    } else {
	set next_week_available false
    }
} 

ad_return_template
